/*  VER 110  TAB P   $Id: common.h,v 1.3 1997/08/14 13:39:42 src Exp $
 *
 *  common header file
 *
 *  copyright 1996, 1997 Egil Kvaleberg, egil@kvaleberg.no
 *  the GNU General Public License applies
 */

#if HAVE_CONFIG_H
#include "../config.h"
#endif

#include "tune.h"

/* standard stuff */
#include <stdio.h>
#include <sys/types.h>
#include <ctype.h>

#if STDC_HEADERS
#  include <stdlib.h>
#  include <string.h>
#else 
#  if HAVE_STDLIB_H
#    include <stdlib.h>
#  endif
#  if HAVE_MALLOC_H
#    include <string.h>
#  endif
#  if HAVE_STRING_H
#    include <string.h>
#  else 
#    if HAVE_STRINGS_H
#      include <strings.h>
#    endif
#  endif
#endif

#if HAVE_UNISTD_H
#  include <unistd.h>
#endif

#if HAVE_LIMITS_H
#  include <limits.h>
#endif

#if TIME_WITH_SYS_TIME
#  include <time.h>
#  include <sys/time.h>
#else
#  if HAVE_SYS_TIME_H
#    include <sys/time.h>
#  else
#    include <time.h>
#  endif
#endif

/*
 *  not all versions define these..
 */
#ifndef PATH_MAX
#define PATH_MAX 1024
#endif

#ifndef __STDC__
extern int errno;
#endif

/*
 *  own socket stuff
 */
#include "sock.h"

/* 
 *  names
 */
char *hostname; 		/* current NNTP server */
char *spoolname;		/* outgoing spool */
char *hostport; 		/* port for NNTP server */
char *pname;			/* this program */
char *spooldir; 		/* news spool */
#define NNTP_PORT "nntp"

/* 
 *  misc status
 */
int post_allowed;

/* 
 *  log message types 
 */
#define L_ERR	 '?'
#define L_ERRno  '!'
#define L_INFO	 '&'
#define L_DEBUG  '='
#define L_DEBUG4 '4'
#define L_GET	 '<'
#define L_PUT	 '>'
