/*  VER 095  TAB P   $Id: proto.h,v 1.2 1997/08/14 13:39:44 src Exp $
 *
 *  function prototypes
 *
 *  copyright 1996, 1997 Egil Kvaleberg, egil@kvaleberg.no
 *  the GNU General Public License applies
 */

/* doit.c */
int 
doit(void);

/* statistics.c */
void	    
statistics(time_t starttime,time_t endtime);

/* despool.c */
void 
despool(char *article_name);
char *
despool_line(void);

/* putarticle.c */
char *
submit_article(char *articlename);

/* lock.c */
void 
lock(char *dir_name,char *lock_name);
void 
unlock(void);
void 
unlock_exit(int n);

/* util.c */
char *
news_home(void);
int 
append_file(FILE *f,char *name,FILE *af);
int 
rename_file(char *from,char *to);
time_t
what_date(FILE *f,char *name);
time_t
how_old(FILE *f, char *name);
int 
is_regular(FILE *f, char *name);
void 
build_alt_filename(char *where,char *home,char *fixed,char *alt);
void 
build_filename(char *where,char *arg1,char *arg2,char *arg3,char *arg4);
char *
text_time(time_t t);

/* logmsg.c */
void 
log_open(void);
void 
log_msg(int type, char *fmt, ...);

/* server.c */
int 
open_server(char *host,char *port);
void 
close_server(void);
int 
get_server_nntp(char *line, int size);
int 
get_server_msg(char *line, int size);
void 
put_server(char *line);
int 
put_server_msg(char *line);

/* socket.c */
int 
socket_open(char *hostname, char *service, SOCKET_D *sock);
void 
socket_close(SOCKET_D *sock);
int 
get_socket(char *line, int size, SOCKET_D *sock);
int 
put_socket(char *line, SOCKET_D *sock);

/* getarticle.c */
int 
select_group(char *group,long *firstp,long *lastp);
int 
fetch_article(long where);

/* request.c */
int 
put_request(char *request, int (*fn)(), long where);
int 
flush_request(void);

/* pull.c */
void 
pull(char *hostname);
void 
pull_cleanup(void);

/* incoming.c */
int 
write_in_coming(char *buffer,long bytecount);
int 
flush_spool(void);

/* active.c */
int 
is_active(char *group);
int 
is_in_active(char *group);
int 
unseen_active(char *group);
void 
load_active(void);
void
clear_active(void);

/* sys.c */
void 
load_sys(void);
int 
sys_allow(char *group);

/* auth.c */
void 
get_authinfo(char *file);
void 
do_authinfo(char *username,char *password);
void 
do_mode_reader(void);

/* history.c */
void 
history_done(void);
int 
history_lookup(char *msgid);

/* msgid.c */
int 
new_msgid(char *msgid);

/* hash.c */
int 
hashindex(char *key,int hashlen);

/* exec.c */
int 
ctlinnd(char *arg1, char *arg2);
int 
script(char *program, int in, int out);
int	   
wait_pid(int pid);
void 
program_open(char *program, SOCKET_D *sock);
FILE *
fork_write(char *path, int *pidp, char *arg1, char *arg2);
FILE *
open_any(char *any,int *pidp);
int	
close_any(FILE *f,int pid);

/* telnet.c */
int 
read_telnet(char *line, int size, SOCKET_D *sock);
int 
write_telnet(char *line, SOCKET_D *sock);

/* script.c */
void 
chat_update(char *line,SOCKET_D *sock);

/* title.c */
void 
begintitle(int argc, char **argv, char **envp);
void 
settitle(char *name);
void 
progtitle(char *what);
void 
progtitle2(char *what,char *more);

/* wildmat.c */
int 
wildmat(char *text, char *p);

/* bounce.c */
int  
bounce_msg(char *to, FILE *art,char *filename, char *msgid, char *reason);

/* rnews.c */
FILE *
open_rnews(int *pid);
int 
close_rnews(FILE *f, int pid);

/* mfilter.c */
int  
do_mfilter(char *msgid);

/* list.c */
int  
get_list(void);
int  
get_desc(void);
